=== modules/CMakeLists.txt ===
include("cppserver.cmake")
include("barrier.cmake")
include("sslconf.cmake")
include("quazip.cmake")
include("QtZeroConf.cmake")
include("CuteIPC.cmake")
