=== src/CMakeLists.txt ===
# share libraries
add_subdirectory(lib)

add_subdirectory(apps)

# compat v20 daemon app
add_subdirectory(compat)
