=== 3rdparty/CppServer/modules/CMakeLists.txt ===
include("asio.cmake")
if (NOT ANDROID)
include("CppLogging.cmake")
else()
include("android-uuid.cmake")
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
endif()
include("CppCommon.cmake")
if(NOT CPPSERVER_MODULE)
    include("Catch2.cmake")
    include("cpp-optparse.cmake")
    include("CppBenchmark.cmake")
endif()
