=== debian/changelog ===
dde-cooperation (1.0.2-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@linuxdeepin.com>  Fri, 22 Nov 2024 17:13:24 +0800

dde-cooperation (1.0.2) unstable; urgency=medium

  * v1.0.2 version update.
  * feat: [cast]Update QR with url
  * fix: [ui]Fix some ui layout issues
  * fix: [share]Terminate all process before start one
  * fix: [share]Make the peripheral share controlable by setting
  * fix: Fix the vnc view not change mode if mobile has changed show mode
  * fix: [memory leaks] Fix memory leaks

 -- re2zero <yangwu@uniontech.com>  Thu, 21 Nov 2024 04:55:18 +0800

dde-cooperation (1.0.1) unstable; urgency=medium

  * v1.0.1 version update.
  * fix some issues.

 -- re2zero <yangwu@uniontech.com>  Fri, 01 Nov 2024 11:52:26 +0800

dde-cooperation (0.9.2) unstable; urgency=medium

  * v0.9.2 version update.
  * fix some issues.

 -- re2zero <yangwu@uniontech.com>  Tue, 08 Oct 2024 15:08:16 +0800

dde-cooperation (0.9.1) unstable; urgency=medium

  * v0.9.1 version update.
  * fix discovery issue with old protocol version.

 -- re2zero <yangwu@uniontech.com>  Fri, 20 Sep 2024 14:16:16 +0800

dde-cooperation (0.9.0) unstable; urgency=medium

  * v0.9.0 version update.
  * added a new communication method that is compatible with previous versions.

 -- liujinchang <liujinchang@uniontech.com>  Wed, 28 Aug 2024 09:51:44  +0800

dde-cooperation (0.8.0) unstable; urgency=medium

  * v0.8.0 version update.
  * refactor structure and reimplement.

 -- re2zero <yangwu@uniontech.com>  Fri, 17 May 2024 16:46:16 +0800
