=== debian/control ===
Source: dde-cooperation
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 debhelper (>= 11),
 pkg-config,
 cmake,
 qtchooser,
 qtbase5-dev,
 qttools5-dev-tools,
 qttools5-dev,
 libqt5svg5-dev,
 libdtkwidget-dev,
 libdtkgui-dev,
 libdtkcore-dev,
 libdtkcore5-bin,
 libssl-dev,
 libzip-dev,
 libcurl4-openssl-dev,
 libxtst-dev,
 libavahi-compat-libdnssd-dev,
 libxinerama-dev,
 libxrandr-dev,
 libxrender-dev,
 libxkbcommon-dev,
 libx11-dev,
 libice-dev,
 libsm-dev,
 uuid-dev,
 libdisplayjack-dev | hello,
 libsystemd-dev,
 libqrencode-dev,
Standards-Version: 4.1.3
Section: utils
Homepage: http://www.deepin.org

Package: dde-cooperation-dev
Section: libdevel
Architecture: any
Depends: dde-cooperation (= ${binary:Version}), ${misc:Depends}
Description: Development package for deepin cooperation application
 This package contains the header files and static libraries

Package: deepin-data-transfer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: deepin data transfer application
 Deepin Desktop Environment (DDE) - data transfer application.

Package: dde-cooperation
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
 libqrencode4
Replaces:
 QtZeroConf,
 dde-cooperation-transfer (<< 1.0.0),
 dde-cooperation-daemon (<< 1.0.0),
Description: deepin cooperation application
 Deepin Desktop Environment (DDE) - cooperation application.

Package: dde-cooperation-transfer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dde-cooperation (= ${binary:Version})
Description: deepin file delivery
 Deepin Desktop Environment (DDE) - file transfer application.
