## dde-cooperation 1.1.2

=== debian/changelog ===
dde-cooperation (1.1.2) unstable; urgency=medium

  * v1.1.2 version update.
  * fix: Fix crash issue after network change.

 -- re2zero <yangwu@uniontech.com>  Tue, 29 Apr 2025 19:21:18 +0800

dde-cooperation (1.1.1) unstable; urgency=medium

  * v1.1.1 version update.
  * fix: Fix miss the dynamic library issue.

 -- re2zero <yangwu@uniontech.com>  Fri, 25 Apr 2025 15:55:10 +0800

dde-cooperation (1.1.0) unstable; urgency=medium

  * v1.1.0 version update.
  * feat: refactoring code structure.

 -- re2zero <yangwu@uniontech.com>  Thu, 24 Apr 2025 19:55:10 +0800

dde-cooperation (1.0.12) unstable; urgency=medium

  * v1.0.12 version update.
  * feat: Remove displayjack kvm depend.

 -- re2zero <yangwu@uniontech.com>  Thu, 27 Mar 2025 13:25:42 +0800

dde-cooperation (1.0.11) unstable; urgency=medium

  * v1.0.11 version update.

 -- re2zero <yangwu@uniontech.com>  Thu, 20 Mar 2025 18:55:55 +0800

dde-cooperation (1.0.10) unstable; urgency=medium

  * v1.0.10 version update.
  * Fix work with compat target issue.
  * Fix close dialog not show in center.
  * fix: Fix incorrect default setting.
  * fix: Fix dialog does not show in center.
  * fix: Fix notification do not update issue.

 -- re2zero <yangwu@uniontech.com>  Thu, 20 Feb 2025 19:33:13 +0800

dde-cooperation (1.0.9) unstable; urgency=medium

  * v1.0.9 version update.
  * fix: fix CI build issue.

 -- re2zero <yangwu@uniontech.com>  Mon, 20 Jan 2025 17:30:43 +0800

dde-cooperation (1.0.8) unstable; urgency=medium

  * v1.0.8 version update.
  * [ipc]Enable Qt6 support.
  * fix: Workaround notification incorrect issue.
  * Fix light style issue.
  * [vnc]Fix display incorrect image issue.

 -- re2zero <yangwu@uniontech.com>  Mon, 20 Jan 2025 15:30:43 +0800

dde-cooperation (1.0.7) unstable; urgency=medium

  * v1.0.7 version update.

 -- re2zero <yangwu@uniontech.com>  Thu, 2 Jan 2025 02:57:05 +0800

dde-cooperation (1.0.6) unstable; urgency=medium

  * v1.0.6 version update.
  * fix: Fix resource release
  * fix: [dt]Disable compat for datatransfer
  * fix: Fix memory leak

 -- re2zero <yangwu@uniontech.com>  Thu, 26 Dec 2024 02:57:05 +0800

dde-cooperation (1.0.5) unstable; urgency=medium

  * v1.0.5 version update.
  * chore: [ci]Change msvc action
  * chore: Change depending
  * fix: Fix file transfer was freezed
  * feat: Add download link

 -- re2zero <yangwu@uniontech.com>  Sat, 14 Dec 2024 04:28:55 +0800

dde-cooperation (1.0.4) unstable; urgency=medium

  * v1.0.4 version update.
  * fix: Fix it still continue cooperation even has been canceled
  * chore: Rename daemon backend and remove unused codes
  * fix: Fix incorrect status issue
  * feat: [plugin]Move the file deliver plugin from extension project
  * fix: Fix file delivery and single app show issue

 -- re2zero <yangwu@uniontech.com>  Sat, 07 Dec 2024 11:19:12 +0800

dde-cooperation (1.0.3) unstable; urgency=medium

  * v1.0.3 version update.
  * fix: [ui]workaround crash on treeland.
  * refactor: [compat]Add macro define for compatibile mode

 -- re2zero <yangwu@uniontech.com>  Sat, 30 Nov 2024 01:16:56 +0800
